package fr.ippon.kafkaLatency.utils;

import org.apache.commons.beanutils.PropertyUtilsBean;
import org.apache.commons.configuration2.PropertiesConfiguration;
import org.apache.commons.configuration2.builder.FileBasedConfigurationBuilder;
import org.apache.commons.configuration2.builder.fluent.Parameters;
import org.apache.commons.configuration2.ex.ConfigurationException;

import java.beans.IntrospectionException;

public class Config {

    private static PropertiesConfiguration config;

    static {
        try {
            FileBasedConfigurationBuilder<PropertiesConfiguration> builder =
                    new FileBasedConfigurationBuilder<PropertiesConfiguration>(PropertiesConfiguration.class)
                            .configure(new Parameters().properties()
                                    .setFileName("config.properties")
                                    .setThrowExceptionOnMissing(true)
                                    .setIncludesAllowed(false));
            config = builder.getConfiguration();

        } catch (ConfigurationException cex) {

        }
    }

    static public String getProperty(String key) throws IntrospectionException {
        return (String)config.getProperty(key);
    }


    static public Integer getIntProperty(String key) throws IntrospectionException {
        return Integer.valueOf(getProperty(key));
    }

}
