package fr.ippon.kafkaLatency.utils;

import org.apache.log4j.Logger;

import java.beans.IntrospectionException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.LongSummaryStatistics;

/**
 * IPPON 2018.
 */
public class UtilStats implements Serializable {
    static List<Long> lStep = Collections.synchronizedList(new ArrayList());
    static List<Long> lTotal = Collections.synchronizedList(new ArrayList());

    private static long step;
    private static long total;

    private final static Logger logger = Logger.getLogger(UtilStats.class);

    static {
        try {
            step = Integer.valueOf(Config.getProperty("stats.step"));
            total = Integer.valueOf(Config.getProperty("stats.total"));
        } catch (IntrospectionException e) {
            logger.error("Error " + e.getMessage());
        }

    }

    public static void treatStats(long millis) {
        synchronized (lTotal) {
            synchronized (lStep) {
                lStep.add(millis);

                if (lStep.size() > (step - 1)) {
                    LongSummaryStatistics stats = lStep.stream()
                            .mapToLong((x) -> x)
                            .summaryStatistics();

                    logger.info("Stats : " + stats);
                    lStep.clear();
                }
            }
            lTotal.add(millis);
            if (lTotal.size() > (total - 1)) {
                LongSummaryStatistics stats = lTotal.stream()
                        .mapToLong((x) -> x)
                        .summaryStatistics();

                logger.info("Stats total: " + stats);
                lTotal.clear();
            }

        }
    }
}
